// -*- mode: objc; tab-width: 4 -*-

//  This file is part of Byeoroo, a Korean input method server for X11.
//  Copyright (C) 1997  Park, Jae-hyon.
//  
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License , or
//  (at your option) any later version.
//  
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//  
//  You should have received a copy of the GNU General Public License
//  along with this program; see the file COPYING.  If not, write to
//  the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
//  Boston, MA 02111-1307, USA.
//  
//  You may contact the author by:
//     e-mail:  jhpark@entropy.kaist.ac.kr
//       mail:  Park, Jae-hyon
//              Physics Department, 305-701
//              Korea Advanced Institute of Science and Technology
//              Taejon, South Korea


// Chinese dictionary class and utility functions not dependent on X.

#import  <objc/Object.h>

#define CDICEXT      ".cd"
#define CDICINDEXEXT ".cdi"

typedef unsigned int CDIndex;

@class PerFileDic;

BOOL sort_and_index(char *path);

@interface ChineseDic : Object
{
@public
	char **words;
	int words_count;

@protected
	PerFileDic **dic_list;
	int ndics;
}

- init;							// search_path defaults to ".".
- initFromSearchPath:(char *)search_path;
- free;

- lookup:(char *)korean;
	
//
//  private methods
//

- freeWordList;

@end

@interface PerFileDic : Object
{
@public
	char **words;
	int words_count;

@protected
	char *cd;					// Chinese dictionary file
	int cd_size;				// Chinese dictionary file size
	CDIndex *cdi;				// Chinese dictionary index file
	int cdi_nmemb;				// # of members in the index file
}

- init;							// must not be called.
- initFromFile:(char *)path;
- free;

- lookup:(char *)korean;

//
//  private methods
//

- freeWordList;

@end
