// -*- mode: objc; tab-width: 4 -*-

//  This file is part of Byeoroo, a Korean input method server for X11.
//  Copyright (C) 1997  Park, Jae-hyon.
//  
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License , or
//  (at your option) any later version.
//  
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//  
//  You should have received a copy of the GNU General Public License
//  along with this program; see the file COPYING.  If not, write to
//  the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
//  Boston, MA 02111-1307, USA.
//  
//  You may contact the author by:
//     e-mail:  jhpark@entropy.kaist.ac.kr
//       mail:  Park, Jae-hyon
//              Physics Department, 305-701
//              Korea Advanced Institute of Science and Technology
//              Taejon, South Korea


// This class is specialized for Byeoroo.

#import  "KText.h"

@interface HistoryText : KText
{
	Widget sink;
	Dimension max_width;
	Position left_margin;
	Position right_margin;
	BOOL resize;
}

- initFromKDF:(char *)kdf_path KSM:(char *)ksm_path
   withWidget:(Widget)text translator:(Widget)tw;

- receiveEvent:(XEvent *)ev;
- (char *)getComposingChar;
- (EventMask)getTextEventMask;
- setLeftMargin:(Position)num;
- setRightMargin:(Position)num;
- (KeyboardType)getKeyboard;
- setString:(char *)string;
- setMaxWidth:(Dimension)width;
- setResize:(BOOL)yesno;
- insertString:(char *)string;

//
//  private methods
//

- makeCaretVisible;
- resize;

- (void)textNextLine:(Widget)w :(XEvent *)ev :(String *)p :(Cardinal *)np;
- (void)textPreviousLine:(Widget)w :(XEvent *)ev :(String *)p :(Cardinal *)np;
- (void)textNextPage:(Widget)w :(XEvent *)ev :(String *)p :(Cardinal *)np;
- (void)textPreviousPage:(Widget)w :(XEvent *)ev :(String *)p :(Cardinal *)np;
- (void)textBeginningOfFile:(Widget)w :(XEvent *)ev :(String *)p :(Cardinal *)np;
- (void)textEndOfFile:(Widget)w :(XEvent *)ev :(String *)p :(Cardinal *)np;
- (void)textScrollOneLineUp:(Widget)w :(XEvent *)ev :(String *)p :(Cardinal *)np;
- (void)textScrollOneLineDown:(Widget)w :(XEvent *)ev :(String *)p :(Cardinal *)np;
- (void)textNewlineAndIndent:(Widget)w :(XEvent *)ev :(String *)p :(Cardinal *)np;
- (void)textNewlineAndBackup:(Widget)w :(XEvent *)ev :(String *)p :(Cardinal *)np;
- (void)textNewline:(Widget)w :(XEvent *)ev :(String *)p :(Cardinal *)np;
- (void)textInsertFile:(Widget)w :(XEvent *)ev :(String *)p :(Cardinal *)np;
- (void)textSearch:(Widget)w :(XEvent *)ev :(String *)p :(Cardinal *)np;
- (void)textFormParagraph:(Widget)w :(XEvent *)ev :(String *)p :(Cardinal *)np;
- (void)textInsertFileAction:(Widget)w :(XEvent *)ev :(String *)p :(Cardinal *)np;
- (void)textDoSearchAction:(Widget)w :(XEvent *)ev :(String *)p :(Cardinal *)np;
- (void)textDoReplaceAction:(Widget)w :(XEvent *)ev :(String *)p :(Cardinal *)np;
- (void)textPopdownSearchAction:(Widget)w :(XEvent *)ev :(String *)p :(Cardinal *)np;

@end
