// -*- mode: objc; tab-width: 4 -*-

//  This file is part of Byeoroo, a Korean input method server for X11.
//  Copyright (C) 1997  Park, Jae-hyon.
//  
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License , or
//  (at your option) any later version.
//  
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//  
//  You should have received a copy of the GNU General Public License
//  along with this program; see the file COPYING.  If not, write to
//  the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
//  Boston, MA 02111-1307, USA.
//  
//  You may contact the author by:
//     e-mail:  jhpark@entropy.kaist.ac.kr
//       mail:  Park, Jae-hyon
//              Physics Department, 305-701
//              Korea Advanced Institute of Science and Technology
//              Taejon, South Korea


#import  <objc/Object.h>
#include <X11/X.h>

#define KSMEXT     ".ksm"
#define DEFAULTKSM ("raw" KSMEXT)

struct _keycode_to_string_map {
    // map from
    KeyCode keycode;
    unsigned int modifier;
    unsigned int modifier_mask;
    // to
    char *string;
    int length;
};

@interface KeyTranslator : Object
{
    char *string_return;
    int string_size;
    char *tt;			// translation file string
    int tt_size;		// translation file string size
    struct _keycode_to_string_map *map;
    int number;
}

- init;				// cannot be called.
- initFromFile:(char *)path;
- free;

- (char *)stringFromKeycode:(KeyCode)keycode modifier:(unsigned int)modifier;
- (BOOL)translating;

//
//  private methods
//

- readKSM;

@end
